"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
class CFGNode {
  constructor() {
    let successors = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
    let predecessors = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

    this.type = "CFGNode";
    this.successors = successors;
    this.predecessors = predecessors;
  }
  addSucc(succ) {
    this.successors.push(succ);
  }
  addPred(pred) {
    this.predecessors.push(pred);
  }
}

exports.CFGNode = CFGNode;
const entry = exports.entry = new CFGNode();
const exit = exports.exit = new CFGNode();

class ControlFlowGraph {
  constructor() {
    this.implicitReturn = {};
    this._entry = entry;
  }
  getEntry() {
    return this._entry;
  }
  isImplicitReturn(node) {
    return node === this.implicitReturn;
  }
}

exports.ControlFlowGraph = ControlFlowGraph;
class ControlFlowAnalysis {
  constructor() {
    this.cfg = null;
    this.root = null;
    this.exceptionHandler = [];
  }
  getCfg() {
    return this.cfg;
  }
  process() {}
}
exports.ControlFlowAnalysis = ControlFlowAnalysis;