export class CFGNode {
  constructor(successors = [], predecessors = []) {
    this.type = "CFGNode";
    this.successors = successors;
    this.predecessors = predecessors;
  }
  addSucc(succ) {
    this.successors.push(succ);
  }
  addPred(pred) {
    this.predecessors.push(pred);
  }
}

export const entry = new CFGNode();
export const exit = new CFGNode();

export class ControlFlowGraph {
  constructor() {
    this.implicitReturn = {};
    this._entry = entry;
  }
  getEntry() {
    return this._entry;
  }
  isImplicitReturn(node) {
    return node === this.implicitReturn;
  }
}

export class ControlFlowAnalysis {
  constructor() {
    this.cfg = null;
    this.root = null;
    this.exceptionHandler = [];
  }
  getCfg() {
    return this.cfg;
  }
  process() {
  }
}
